//
// wemu4 : F180 emulator for Windows ver4.00
//  (c) Junichi Akita (akita@fun.ac.jp), 2003.6.9
//

// wemuView.cpp : CWemuView NX̓̒`s܂B
//

#include "stdafx.h"
#include "wemu.h"

#include "wemuDoc.h"
#include "wemuView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWemuView

IMPLEMENT_DYNCREATE(CWemuView, CFormView)

BEGIN_MESSAGE_MAP(CWemuView, CFormView)
	//{{AFX_MSG_MAP(CWemuView)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_LBUTTONDOWN()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_RBUTTONDOWN()
	ON_BN_CLICKED(IDC_USE_F1, OnUseF1)
	ON_BN_CLICKED(IDC_USE_F2, OnUseF2)
	ON_BN_CLICKED(IDC_USE_F3, OnUseF3)
	ON_BN_CLICKED(IDC_USE_F4, OnUseF4)
	ON_BN_CLICKED(IDC_USE_F5, OnUseF5)
	ON_BN_CLICKED(IDC_USE_E1, OnUseE1)
	ON_BN_CLICKED(IDC_USE_E2, OnUseE2)
	ON_BN_CLICKED(IDC_USE_E3, OnUseE3)
	ON_BN_CLICKED(IDC_USE_E4, OnUseE4)
	ON_BN_CLICKED(IDC_USE_E5, OnUseE5)
	ON_COMMAND(IDC_TOGGLE_MODE, OnToggleMode)
	ON_EN_CHANGE(IDC_DEVI, OnChangeDevi)
	ON_EN_CHANGE(IDC_EMPORT, OnChangeEmport)
	ON_EN_CHANGE(IDC_FMPORT, OnChangeFmport)
	ON_BN_CLICKED(IDC_SET_EMHOST, OnSetEmhost)
	ON_BN_CLICKED(IDC_SET_FMHOST, OnSetFmhost)
	ON_BN_CLICKED(IDC_SET_CHOST, OnSetChost)
	ON_EN_CHANGE(IDC_CPORT, OnChangeCport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWemuView NX̍\z/

CWemuView::CWemuView()
	: CFormView(CWemuView::IDD)
{
	//{{AFX_DATA_INIT(CWemuView)
		// : ClassWizard ͂̈ʒuɃȍǉ܂B
	//}}AFX_DATA_INIT
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

}

CWemuView::~CWemuView()
{
}

void CWemuView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWemuView)
		// : ClassWizard ͂̈ʒu DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BOOL CWemuView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWemuView NX̐ff

#ifdef _DEBUG
void CWemuView::AssertValid() const
{
	CFormView::AssertValid();
}

void CWemuView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CWemuDoc* CWemuView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWemuDoc)));
	return (CWemuDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWemuView NX̃bZ[W nh

void CWemuView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	((CButton *)GetDlgItem(IDC_USE_F1))->SetCheck(frobot[0].use);
	((CButton *)GetDlgItem(IDC_USE_E1))->SetCheck(erobot[0].use);
	((CButton *)GetDlgItem(IDC_USE_F2))->SetCheck(frobot[1].use);
	((CButton *)GetDlgItem(IDC_USE_E2))->SetCheck(erobot[1].use);
	((CButton *)GetDlgItem(IDC_USE_F3))->SetCheck(frobot[2].use);
	((CButton *)GetDlgItem(IDC_USE_E3))->SetCheck(erobot[2].use);
	((CButton *)GetDlgItem(IDC_USE_F4))->SetCheck(frobot[3].use);
	((CButton *)GetDlgItem(IDC_USE_E4))->SetCheck(erobot[3].use);
	((CButton *)GetDlgItem(IDC_USE_F5))->SetCheck(frobot[4].use);
	((CButton *)GetDlgItem(IDC_USE_E5))->SetCheck(erobot[4].use);
	CString s;
	s.Format("%d",cPort); GetDlgItem(IDC_CPORT)->SetWindowText(s);
	s.Format("%d",fmPort); GetDlgItem(IDC_FMPORT)->SetWindowText(s);
	s.Format("%d",emPort); GetDlgItem(IDC_EMPORT)->SetWindowText(s);
	GetDlgItem(IDC_SET_CHOST)->EnableWindow(FALSE);
	GetDlgItem(IDC_SET_FMHOST)->EnableWindow(FALSE);
	GetDlgItem(IDC_SET_EMHOST)->EnableWindow(FALSE);
	s.Format("%d",devi0); ((CEdit *)GetDlgItem(IDC_DEVI))->SetWindowText(s);
}

void CWemuView::OnUseF1() {	frobot[0].use = 1 - frobot[0].use; Invalidate(NULL);}
void CWemuView::OnUseE1() {	erobot[0].use = 1 - erobot[0].use; Invalidate(NULL);}
void CWemuView::OnUseF2() {	frobot[1].use = 1 - frobot[1].use; Invalidate(NULL);}
void CWemuView::OnUseE2() {	erobot[1].use = 1 - erobot[1].use; Invalidate(NULL);}
void CWemuView::OnUseF3() {	frobot[2].use = 1 - frobot[2].use; Invalidate(NULL);}
void CWemuView::OnUseE3() {	erobot[2].use = 1 - erobot[2].use; Invalidate(NULL);}
void CWemuView::OnUseF4() {	frobot[3].use = 1 - frobot[3].use; Invalidate(NULL);}
void CWemuView::OnUseE4() {	erobot[3].use = 1 - erobot[3].use; Invalidate(NULL);}
void CWemuView::OnUseF5() {	frobot[4].use = 1 - frobot[4].use; Invalidate(NULL);}
void CWemuView::OnUseE5() {	erobot[4].use = 1 - erobot[4].use; Invalidate(NULL);}

void CWemuView::OnStart() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	start = 1;	
	struct _timeb tstruct;
	_ftime( &tstruct );
	/* ts : vOJn̎ [s] */
	ts = (double)tstruct.time + tstruct.millitm/1000.0 - te;
	Invalidate(NULL);
	int i;
	NRF = 0; NRE = 0;
	for (i = 0; i < 5; i++){
		if (frobot[i].use == 1) NRF++;
		if (erobot[i].use == 1) NRE++;
	}
}

void CWemuView::OnStop() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	start = 0;
	struct _timeb tstruct;
	_ftime( &tstruct );
	te = (double)tstruct.time + tstruct.millitm/1000.0 - ts;
}

void calc_robot_outline()
{
	int i;
	Point p, pp;
	for (i = 0; i < 5; i++){
		p.x =  FRX[i]/2.0; p.y =  FRY[i]/2.0; pp = rotate(p, frobot[i].dir); frobot[i].p[0].x = pp.x + frobot[i].x; frobot[i].p[0].y = pp.y + frobot[i].y;
		p.x = -FRX[i]/2.0; p.y =  FRY[i]/2.0; pp = rotate(p, frobot[i].dir); frobot[i].p[1].x = pp.x + frobot[i].x; frobot[i].p[1].y = pp.y + frobot[i].y;
		p.x = -FRX[i]/2.0; p.y = -FRY[i]/2.0; pp = rotate(p, frobot[i].dir); frobot[i].p[2].x = pp.x + frobot[i].x; frobot[i].p[2].y = pp.y + frobot[i].y;
		p.x =  FRX[i]/2.0; p.y = -FRY[i]/2.0; pp = rotate(p, frobot[i].dir); frobot[i].p[3].x = pp.x + frobot[i].x; frobot[i].p[3].y = pp.y + frobot[i].y;
		p.x =  ERX[i]/2.0; p.y =  ERY[i]/2.0; pp = rotate(p, erobot[i].dir); erobot[i].p[0].x = pp.x + erobot[i].x; erobot[i].p[0].y = pp.y + erobot[i].y;
		p.x = -ERX[i]/2.0; p.y =  ERY[i]/2.0; pp = rotate(p, erobot[i].dir); erobot[i].p[1].x = pp.x + erobot[i].x; erobot[i].p[1].y = pp.y + erobot[i].y;
		p.x = -ERX[i]/2.0; p.y = -ERY[i]/2.0; pp = rotate(p, erobot[i].dir); erobot[i].p[2].x = pp.x + erobot[i].x; erobot[i].p[2].y = pp.y + erobot[i].y;
		p.x =  ERX[i]/2.0; p.y = -ERY[i]/2.0; pp = rotate(p, erobot[i].dir); erobot[i].p[3].x = pp.x + erobot[i].x; erobot[i].p[3].y = pp.y + erobot[i].y;
	}
}

void CWemuView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	CFormView::OnLButtonDown(nFlags, point);
	CString s;
	double x, y;
	int i, imin;
	double d, dmin;
	x = (double)(point.x - ox) / R; y = (double)(oy - point.y) / R;
	if (selected == -1){
		imin = 0;
		dmin = sqrt((ball.x-x)*(ball.x-x)+(ball.y-y)*(ball.y-y));
		for (i = 0; i < 5; i++){
			d = sqrt((frobot[i].x-x)*(frobot[i].x-x)+(frobot[i].y-y)*(frobot[i].y-y));
			if (d < dmin){dmin = d; imin = i+1;}
			d = sqrt((erobot[i].x-x)*(erobot[i].x-x)+(erobot[i].y-y)*(erobot[i].y-y));
			if (d < dmin){dmin = d; imin = i+6;}
		}
		if (dmin < 10.0){
			selected = imin;
			s.Format("#%d is selected; LEFT:set position, RIGHT:set direction",selected);
			((CFrameWnd *)AfxGetMainWnd())->SetMessageText(s);
			Invalidate(NULL);
		}
	}
	else{
		if (selected == 0){ ball.x = x; ball.y = y;}
		else if (selected <= 5){frobot[selected-1].x = x; frobot[selected-1].y = y;}
		else {erobot[selected-6].x = x; erobot[selected-6].y = y;}
		calc_robot_outline();
		((CFrameWnd *)AfxGetMainWnd())->SetMessageText("");
		Invalidate(NULL);
		selected = -1;
	}
}


void CWemuView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	CFormView::OnRButtonDown(nFlags, point);
	CString s;
	double x, y;
	int i, imin;
	double d, dmin;
	x = (double)(point.x - ox) / R; y = (double)(oy - point.y) / R;
	if (selected == -1){
		imin = 0;
		dmin = sqrt((ball.x-x)*(ball.x-x)+(ball.y-y)*(ball.y-y));
		for (i = 0; i < 5; i++){
			d = sqrt((frobot[i].x-x)*(frobot[i].x-x)+(frobot[i].y-y)*(frobot[i].y-y));
			if (d < dmin){dmin = d; imin = i+1;}
			d = sqrt((erobot[i].x-x)*(erobot[i].x-x)+(erobot[i].y-y)*(erobot[i].y-y));
			if (d < dmin){dmin = d; imin = i+6;}
		}
		if (dmin < 10.0){
			selected = imin;
			s.Format("#%d is selected; LEFT:set position, RIGHT:set direction",selected);
			((CFrameWnd *)AfxGetMainWnd())->SetMessageText(s);
			Invalidate(NULL);
		}
	}
	else {
		if (selected == 0){ball.x = x; ball.y = y;}
		else if (selected <= 5){
			i = selected - 1;
			frobot[i].dir = atan2(y-frobot[i].y, x-frobot[i].x) / PI180;
			if (frobot[i].dir < 0) frobot[i].dir += 360.0;
		}
		else {
			i = selected - 6;
			erobot[i].dir = atan2(y-erobot[i].y, x-erobot[i].x) / PI180;
			if (erobot[i].dir < 0) erobot[i].dir += 360.0;
		}
		calc_robot_outline();
		((CFrameWnd *)AfxGetMainWnd())->SetMessageText("");
		Invalidate(NULL);
		selected = -1;
	}
}

void CWemuView::OnTimer(UINT nIDEvent) 
{
	CFormView::OnTimer(nIDEvent);
	CTime theTime = CTime::GetCurrentTime();

	struct _timeb tstruct;
	_ftime( &tstruct );

	double dt;
	int min, sec, msec;
	dt = (double)tstruct.time + tstruct.millitm/1000.0 - ts;
	min = (int)(dt/60.0);
	sec = (int)(dt - min*60.0);
	msec = (int)(dt * 1000.0) % 1000;
	if (start == 1){
		CString s;
		s.Format("Waiting... C(%d) Y(%d) B(%d) t=%d", cPort, fmPort, emPort, t0);
#define DRAW_CYCLE 3
		if ((t0 % DRAW_CYCLE) == 0){
			((CFrameWnd *)AfxGetMainWnd())->SetMessageText(s);
			Invalidate(NULL);
		}
		t0++;
	}
	ball.x0 = ball.x; ball.y0 = ball.y;
	int i;
	for (i = 0; i < 5; i++){
		erobot[i].x0 = erobot[i].x; erobot[i].y0 = erobot[i].y;
		frobot[i].x0 = frobot[i].x; frobot[i].y0 = frobot[i].y;
	}
/*
	if (start == 1){
		CString ss, send_string, status_string;
		int i; Point p, pp;
		NRF = 0; NRE = 0;
		for (i = 0; i < 5; i++) if (frobot[i].use == 1) NRF++;
		for (i = 0; i < 5; i++) if (erobot[i].use == 1) NRE++;

		send_string.Format("%d %d %d %d %d %d %d ", t0, MAP(FX), MAP(FY), MAP(ball.x0)+devi(), MAP(ball.y0)+devi(), NRF, NRE);
		ball.x0 = ball.x; ball.y0 = ball.y;
		
		for (i = 0; i < 5; i++){
			if (frobot[i].use == 1){
				ss.Format("%d %d ", MAP(frobot[i].x0)+devi(), MAP(frobot[i].y0)+devi());
				send_string += ss;
				p.x =  -FMD; p.y =  0; pp = rotate(p, frobot[i].dir);
				ss.Format("%d %d ", MAP(frobot[i].x0+pp.x)+devi(), MAP(frobot[i].y0+pp.y)+devi());
				send_string += ss;
				frobot[i].x0 = frobot[i].x; frobot[i].y0 = frobot[i].y;
			}
		}
		for (i = 0; i < 5; i++){
			if (erobot[i].use == 1){
				ss.Format("%d %d ", MAP(erobot[i].x0)+devi(), MAP(erobot[i].y0)+devi());
				erobot[i].x0 = erobot[i].x; erobot[i].y0 = erobot[i].y;
				send_string += ss;
			}
		}
//		status_string.Format("t = %d : %d %d %d %d", t0, fcPort, fmPort, ecPort, emPort);
//		((CFrameWnd *)AfxGetMainWnd())->SetMessageText(status_string);
		
		Invalidate(NULL); t0++;
		CWemuApp *app = (CWemuApp *)AfxGetApp();

		

		send_string.Format("%d %d %d %d %d %d %d ", t0, MAP(FX), MAP(FY), MAP(ball.x), MAP(ball.y), NRE, NRF);
		for (i = 0; i < 5; i++){
			if (erobot[i].use == 1){
				ss.Format("%d %d ", MAP(erobot[i].x), MAP(erobot[i].y));
				send_string += ss;
				p.x =  -EMD; p.y =  0; pp = rotate(p, erobot[i].dir);
				ss.Format("%d %d ", MAP(erobot[i].x+pp.x), MAP(erobot[i].y+pp.y));
				send_string += ss;
			}
		}
		for (i = 0; i < 5; i++){
			if (erobot[i].use == 1){
				ss.Format("%d %d ", MAP(frobot[i].x), MAP(frobot[i].y));
				send_string += ss;
			}
		}
//	pfSocket = new CAsyncSocket;
//	if (AfxSocketInit(NULL) == 0) AfxMessageBox("init error");
//	if (pfSocket->Create(0, SOCK_DGRAM) == 0) AfxMessageBox("Create() error");
//    if (pfSocket->Connect(fsHost, fsPort) == 0) AfxMessageBox("Connect() error");
//		if (app->peSocket->Send(send_string, strlen(send_string), 0)== SOCKET_ERROR) AfxMessageBox("Send() error");
//	peSocket->Close();
	}
*/
/*
		CString status_string;
		status_string.Format("t = %d : %d %d", t0, MAP(ball.x), MAP(ball.y));
		((CFrameWnd *)AfxGetMainWnd())->SetMessageText(status_string);
		Invalidate(NULL); t0++;
*/
}

int CWemuView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1) return -1;
	if (SetTimer(0,FRAME_CYCLE,NULL) == 0) AfxMessageBox("failed to allocate timer");

	ts = 0;
	return 0;
}

void CWemuView::OnDestroy() 
{
	CFormView::OnDestroy();
	KillTimer(0);	
}

void CWemuView::OnDraw(CDC* pDC) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	double Rx, Ry;
	int W, H;
	CRect rect;
	CPen Pen, *pOldPen;
	CBrush Brush, *pOldBrush;

//	CString ss;
//	ss.Format("%d : %.1f", t0, frobot[0].dir);
//	((CFrameWnd *)AfxGetMainWnd())->SetMessageText(ss);

	((CButton *)GetDlgItem(IDC_USE_F1))->SetCheck(frobot[0].use);
	((CButton *)GetDlgItem(IDC_USE_E1))->SetCheck(erobot[0].use);
	((CButton *)GetDlgItem(IDC_USE_F2))->SetCheck(frobot[1].use);
	((CButton *)GetDlgItem(IDC_USE_E2))->SetCheck(erobot[1].use);
	((CButton *)GetDlgItem(IDC_USE_F3))->SetCheck(frobot[2].use);
	((CButton *)GetDlgItem(IDC_USE_E3))->SetCheck(erobot[2].use);
	((CButton *)GetDlgItem(IDC_USE_F4))->SetCheck(frobot[3].use);
	((CButton *)GetDlgItem(IDC_USE_E4))->SetCheck(erobot[3].use);
	((CButton *)GetDlgItem(IDC_USE_F5))->SetCheck(frobot[4].use);
	((CButton *)GetDlgItem(IDC_USE_E5))->SetCheck(erobot[4].use);



	GetClientRect(rect);
	ox = rect.left + 20; oy = rect.bottom - 10;
	W = rect.right - 40; H = rect.bottom - 160;

	Rx = (double)W / FX; Ry = (double)H / FY; if (Rx < Ry) R = Rx; else R = Ry;

#define DrawLine(x1,y1,x2,y2) {pDC->MoveTo(ox+MAP(x1),oy-MAP(y1)); pDC->LineTo(ox+MAP(x2),oy-MAP(y2));}
#define DrawRect(p1, p2, p3, p4) {pDC->MoveTo(ox+MAP(p1.x),oy-MAP(p1.y)); pDC->LineTo(ox+MAP(p2.x),oy-MAP(p2.y)); pDC->LineTo(ox+MAP(p3.x),oy-MAP(p3.y)); pDC->LineTo(ox+MAP(p4.x),oy-MAP(p4.y)); pDC->LineTo(ox+MAP(p1.x),oy-MAP(p1.y));}
#define DrawCircle(x1,y1,r) {pDC->Ellipse(ox+MAP(x1-r),oy-MAP(y1-r),ox+MAP(x1+r),oy-MAP(y1+r));}

	pDC->FillSolidRect(ox, oy, MAP(FX), -MAP(FY), FIELD);

	pDC->FillSolidRect(ox+MAP(FX), oy-MAP(FY/2.0-GW/2.0), MAP(GH), -MAP(GW), YPING);
	pDC->FillSolidRect(ox, oy-MAP(FY/2.0-GW/2.0), -MAP(GH), -MAP(GW), BPING);

	Pen.CreatePen(PS_SOLID, 1, LINE);
	pOldPen = pDC->SelectObject(&Pen);
	DrawLine(FX/2.0, 0.0, FX/2.0, FY);

	Point p1, p2, p3, p4, pp1;
	p1.x = 0.0; p1.y = 0.0;
	p2.x = FX;  p2.y = 0.0;
	p3.x = FX;  p3.y = FY;
	p4.x = 0.0; p4.y = FY;
	
	DrawRect(p1, p2, p3, p4);

#define RCC (0.5)

	pDC->SelectObject(pOldPen);
	Pen.DeleteObject();
	
	int i;

	Brush.CreateSolidBrush(BALL);
	pOldBrush = pDC->SelectObject(&Brush);
	DrawCircle(ball.x, ball.y, BR);
	pDC->SelectObject(pOldBrush);
	Brush.DeleteObject();

	Pen.CreatePen(PS_SOLID, 1, YPING);
	pOldPen = pDC->SelectObject(&Pen);
	for (i = 0; i < 5; i++){
		if (frobot[i].use == 1){
			DrawRect(frobot[i].p[0], frobot[i].p[1], frobot[i].p[2], frobot[i].p[3]);
		}
	}
	pDC->SelectObject(pOldPen);
	Pen.DeleteObject();

	Brush.CreateSolidBrush(YPING);
	pOldBrush = pDC->SelectObject(&Brush);
	for (i = 0; i < 5; i++){
		if (frobot[i].use == 1)	DrawCircle(frobot[i].x, frobot[i].y, FMr);
	}
	pDC->SelectObject(pOldBrush);
	Brush.DeleteObject();

/*
	Brush.CreateSolidBrush(YMARK);
	pOldBrush = pDC->SelectObject(&Brush);
	for (i = 0; i < 5; i++){
		if (frobot[i].use == 1){
			p1.x =  -FMD; p1.y =  0; pp1 = rotate(p1, frobot[i].dir);
			DrawCircle(frobot[i].x+pp1.x, frobot[i].y+pp1.y, FMr);
		}
	}
	pDC->SelectObject(pOldBrush);
	Brush.DeleteObject();
*/

	double xe, ye, xa1, ya1, xa2, ya2;
	Pen.CreatePen(PS_SOLID, 1, YMARK);
	pOldPen = pDC->SelectObject(&Pen);
	for (i = 0; i < 5; i++){
		if (frobot[i].use == 1){
			xe = frobot[i].x + 2*FMD * cos(frobot[i].dir * PI180);
			ye = frobot[i].y + 2*FMD * sin(frobot[i].dir * PI180);
			xa1 = xe + FMD*cos((frobot[i].dir+150)*PI180);
			ya1 = ye + FMD*sin((frobot[i].dir+150)*PI180);
			xa2 = xe + FMD*cos((frobot[i].dir-150)*PI180);
			ya2 = ye + FMD*sin((frobot[i].dir-150)*PI180);
			DrawLine(frobot[i].x, frobot[i].y, xe, ye);
			DrawLine(xe, ye, xa1, ya1);
			DrawLine(xe, ye, xa2, ya2);
		}
	}
	pDC->SelectObject(pOldPen);
	Pen.DeleteObject();

	Pen.CreatePen(PS_SOLID, 1, BPING);
	pOldPen = pDC->SelectObject(&Pen);
	for (i = 0; i < 5; i++){
		if (erobot[i].use == 1){
			DrawRect(erobot[i].p[0], erobot[i].p[1], erobot[i].p[2], erobot[i].p[3]);
		}
	}
	pDC->SelectObject(pOldPen);
	Pen.DeleteObject();

	Brush.CreateSolidBrush(BPING);
	pOldBrush = pDC->SelectObject(&Brush);
	for (i = 0; i < 5; i++){
		if (erobot[i].use == 1)	DrawCircle(erobot[i].x, erobot[i].y, EMr);
	}
	pDC->SelectObject(pOldBrush);
	Brush.DeleteObject();

/*
	Brush.CreateSolidBrush(BMARK);
	pOldBrush = pDC->SelectObject(&Brush);
	for (i = 0; i < 5; i++){
		if (erobot[i].use == 1){
			p1.x =  -EMD; p1.y =  0; pp1 = rotate(p1, erobot[i].dir);
			DrawCircle(erobot[i].x+pp1.x, erobot[i].y+pp1.y, EMr);
		}
	}
	pDC->SelectObject(pOldBrush);
	Brush.DeleteObject();
*/
	Pen.CreatePen(PS_SOLID, 1, BMARK);
	pOldPen = pDC->SelectObject(&Pen);
	for (i = 0; i < 5; i++){
		if (erobot[i].use == 1){
			xe = erobot[i].x + 2*FMD * cos(erobot[i].dir * PI180);
			ye = erobot[i].y + 2*FMD * sin(erobot[i].dir * PI180);
			xa1 = xe + FMD*cos((erobot[i].dir+150)*PI180);
			ya1 = ye + FMD*sin((erobot[i].dir+150)*PI180);
			xa2 = xe + FMD*cos((erobot[i].dir-150)*PI180);
			ya2 = ye + FMD*sin((erobot[i].dir-150)*PI180);
			DrawLine(erobot[i].x, erobot[i].y, xe, ye);
			DrawLine(xe, ye, xa1, ya1);
			DrawLine(xe, ye, xa2, ya2);
		}
	}
	pDC->SelectObject(pOldPen);
	Pen.DeleteObject();


#define TH (FRY[i]*0.8)
#define RI (5)
	int j;
	Pen.CreatePen(PS_SOLID, 1, YPING);
	pOldPen = pDC->SelectObject(&Pen);
	for (i = 0; i < 5; i++){
		if (frobot[i].use == 1){
			for (j = 0; j < (i+1); j++)
				pDC->Ellipse(ox+MAP(frobot[i].x)+j*(RI+1),oy-MAP(frobot[i].y+TH),ox+MAP(frobot[i].x)+RI+j*(RI+1),oy-MAP(frobot[i].y+TH)+RI);
		}
	}
	pDC->SelectObject(pOldPen);
	Pen.DeleteObject();
	Pen.CreatePen(PS_SOLID, 1, BPING);
	pOldPen = pDC->SelectObject(&Pen);
	for (i = 0; i < 5; i++){
		if (erobot[i].use == 1){
			for (j = 0; j < (i+1); j++)
				pDC->Ellipse(ox+MAP(erobot[i].x)+j*(RI+1),oy-MAP(erobot[i].y+TH),ox+MAP(erobot[i].x)+RI+j*(RI+1),oy-MAP(erobot[i].y+TH)+RI);
		}
	}
	pDC->SelectObject(pOldPen);
	Pen.DeleteObject();

/*
	CFont Font, *pOldFont;
	Font.CreateFont(12, 0, 0, 0, FW_DONTCARE, 0, 0, 0, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, VARIABLE_PITCH, NULL);
	pOldFont = pDC->SelectObject(&Font);
	pDC->SetTextAlign(TA_BASELINE | TA_CENTER);
	CString s;
	for (i = 0; i < 5; i++){
		if (frobot[i].use == 1){ s.Format("f%d", i+1); pDC->TextOut(ox+MAP(frobot[i].x), oy-MAP(frobot[i].y + TH), s); }
		if (erobot[i].use == 1){ s.Format("e%d", i+1); pDC->TextOut(ox+MAP(erobot[i].x), oy-MAP(erobot[i].y + TH), s); }
	}
	pDC->SelectObject(pOldFont);
	Font.DeleteObject();
*/
	CString s;
	s.Format("Y %d - %d B", f_score, e_score);
	GetDlgItem(IDC_SCORE)->SetWindowText(s);

#define SELMARK (8.0)
#define SELCOLOR RGB(200,200,200)
	if (selected != -1){
		double x, y;
		Pen.CreatePen(PS_SOLID, 1, SELCOLOR);
		pOldPen = pDC->SelectObject(&Pen);
		if (selected == 0){x = ball.x; y = ball.y;}
		else if (selected <= 5) {x = frobot[selected-1].x; y = frobot[selected-1].y;}
		else {x = erobot[selected-6].x; y = erobot[selected-6].y;}
		p1.x = x-SELMARK; p1.y = y-SELMARK;
		p2.x = x+SELMARK; p2.y = y-SELMARK;
		p3.x = x+SELMARK; p3.y = y+SELMARK;
		p4.x = x-SELMARK; p4.y = y+SELMARK;
		DrawRect(p1,p2,p3,p4);
		pDC->SelectObject(pOldPen);
		Pen.DeleteObject();
	}
}

void CWemuView::OnToggleMode() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if (start == 1) OnStop(); else OnStart();	
}

void CWemuView::OnChangeDevi() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString s;
	((CEdit *)GetDlgItem(IDC_DEVI))->GetWindowText(s); devi0 = atoi(s);
}

void CWemuView::OnChangeEmport() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDlgItem(IDC_SET_EMHOST)->EnableWindow(TRUE);
}

void CWemuView::OnChangeCport() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDlgItem(IDC_SET_FCHOST)->EnableWindow(TRUE);
	
}

void CWemuView::OnChangeFmport() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CFormView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDlgItem(IDC_SET_FMHOST)->EnableWindow(TRUE);
	
}

void CWemuView::OnSetEmhost() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDlgItem(IDC_SET_EMHOST)->EnableWindow(FALSE);
	CString s;
	((CEdit *)GetDlgItem(IDC_EMPORT))->GetWindowText(s); emPort = atoi(s);

	struct sockaddr_in emaddr;
	closesocket(fdem); 
	if ((fdem = socket(AF_INET, SOCK_DGRAM, 0)) < 0) AfxMessageBox("socket() error");
    memset((char *)&emaddr, 0, sizeof(emaddr));
    emaddr.sin_family = AF_INET; emaddr.sin_addr.s_addr = INADDR_ANY;
	emaddr.sin_port = htons(emPort);
	if (bind(fdem, (struct sockaddr *)&emaddr, sizeof(emaddr)) < 0) AfxMessageBox("bind() error");
	
}

void CWemuView::OnSetChost() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	GetDlgItem(IDC_SET_FCHOST)->EnableWindow(FALSE);
	CString s;
	((CEdit *)GetDlgItem(IDC_CPORT))->GetWindowText(s); cPort = atoi(s);

	struct sockaddr_in caddr;
	closesocket(fdc); 
	if ((fdc = socket(AF_INET, SOCK_DGRAM, 0)) < 0) AfxMessageBox("socket() error");
    memset((char *)&caddr, 0, sizeof(caddr));
    caddr.sin_family = AF_INET; caddr.sin_addr.s_addr = INADDR_ANY;
	caddr.sin_port = htons(cPort);
	if (bind(fdc, (struct sockaddr *)&caddr, sizeof(caddr)) < 0) AfxMessageBox("bind() error");
}

void CWemuView::OnSetFmhost() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDlgItem(IDC_SET_FMHOST)->EnableWindow(FALSE);
	CString s;
	((CEdit *)GetDlgItem(IDC_FMPORT))->GetWindowText(s); fmPort = atoi(s);

	struct sockaddr_in fmaddr;
	closesocket(fdfm); 
	if ((fdfm = socket(AF_INET, SOCK_DGRAM, 0)) < 0) AfxMessageBox("socket() error");
    memset((char *)&fmaddr, 0, sizeof(fmaddr));
    fmaddr.sin_family = AF_INET; fmaddr.sin_addr.s_addr = INADDR_ANY;
	fmaddr.sin_port = htons(fmPort);
	if (bind(fdfm, (struct sockaddr *)&fmaddr, sizeof(fmaddr)) < 0) AfxMessageBox("bind() error");
	
}


